From d6ff82f3d4fdc02d35768b482137e3df4af7e8f4 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Corentin=20S=C3=A9chet?= <csechet@entrouvert.com>
Date: Wed, 16 Mar 2022 15:25:44 +0100
Subject: [PATCH] scss: improve default layout (#62733)

---
 static/avray/_vars.scss                |  3 ++-
 static/caen/_custom.scss               | 14 ++++++++++++++
 static/clermont-ici/_vars.scss         |  1 +
 static/correze-cd19/_vars.scss         |  1 +
 static/grand-chambery/_vars.scss       |  1 +
 static/includes/_layout.scss           | 15 ++++++++++-----
 static/isere-cd38/_vars.scss           |  1 +
 static/la-hague/_vars.scss             |  1 +
 static/la-reunion-region/_vars.scss    |  1 +
 static/lanester/_custom.scss           |  9 +++++++++
 static/lattes/_vars.scss               |  1 +
 static/lille/_vars.scss                |  1 +
 static/marseille/_vars.scss            |  1 +
 static/montpellier-ville/_vars.scss    |  1 +
 static/roannais-icitoyen/_vars.scss    |  1 +
 static/sospel/_vars.scss               |  1 +
 static/thonon-agglomeration/_vars.scss |  1 +
 static/toulouse-metropole/_vars.scss   |  1 +
 static/toulouse/_vars.scss             |  1 +
 static/venissieux/_vars.scss           |  1 +
 20 files changed, 51 insertions(+), 6 deletions(-)

diff --git a/static/avray/_vars.scss b/static/avray/_vars.scss
index 52d51854..0554860c 100644
--- a/static/avray/_vars.scss
+++ b/static/avray/_vars.scss
@@ -2,6 +2,7 @@ $primary-color: #004171;
 
 $width: 1200px;
 $sidebar-position: right;
+$mobile-with: none;
 
 $font-color: black;
 $font-family: Raleway, Arial, sans-serif;
@@ -58,4 +59,4 @@ $wcs-step-background: #fff;
 $wcs-step-current-border-bottom: none;
 $wcs-step-marker-color: #bbb;
 $wcs-step-current-marker-color: #fff;
-$wcs-step-current-marker-background: $primary-color;
\ No newline at end of file
+$wcs-step-current-marker-background: $primary-color;
diff --git a/static/caen/_custom.scss b/static/caen/_custom.scss
index 4e6db76a..ea67b01a 100644
--- a/static/caen/_custom.scss
+++ b/static/caen/_custom.scss
@@ -147,6 +147,12 @@ main {
 //	HEADER
 //
 
+div#header {
+	@media ($max-mobile-viewport) {
+		max-width: $mobile-width;
+	}
+}
+
 h1#logo.has-logo {
 	padding-left: 0;
 	a {
@@ -663,6 +669,7 @@ footer {
 	background: url(img/bandeau-footer.png) no-repeat;
 	background-size: 100% 50px;
 }
+
 #footer-wrapper {
 	margin-top: 50px;
 
@@ -676,6 +683,12 @@ footer {
 	}
 }
 
+div#footer {
+	@media ($max-mobile-viewport) {
+		max-width: $mobile-width;
+	}
+}
+
 // MISC
 
 a.lien {
@@ -698,3 +711,4 @@ a.lien {
 		content: url('img/fleche.svg');
 	}
 }
+
diff --git a/static/clermont-ici/_vars.scss b/static/clermont-ici/_vars.scss
index df22e231..bf09a8b1 100644
--- a/static/clermont-ici/_vars.scss
+++ b/static/clermont-ici/_vars.scss
@@ -40,6 +40,7 @@ $font-size: 93.75%;
 
 $width: 95rem;
 $mobile-limit: 1024px;
+$mobile-width: none;
 $sidebar-width: 25%;
 $sidebar-min-width: 18rem;
 $sidebar-columns-gutter: 40px;
diff --git a/static/correze-cd19/_vars.scss b/static/correze-cd19/_vars.scss
index 14e608c5..65bd0014 100644
--- a/static/correze-cd19/_vars.scss
+++ b/static/correze-cd19/_vars.scss
@@ -5,6 +5,7 @@ $font-color: #444;
 $font-size: 100%;
 $font-family: "Fira Sans", sans-serif;
 $width: 1350px;
+$mobile-width: none;
 
 $nav-background: #747474;
 $nav-color: white;
diff --git a/static/grand-chambery/_vars.scss b/static/grand-chambery/_vars.scss
index f97e68fc..811c7253 100644
--- a/static/grand-chambery/_vars.scss
+++ b/static/grand-chambery/_vars.scss
@@ -6,6 +6,7 @@ $bgblue: #577c90;
 $primary-color: $red !default;
 
 $width: 1210px !default;
+$mobile-width: none;
 $font-family: "Open Sans", sans-serif;
 $font-color: #000 !default;
 $font-size: 100% !default;
diff --git a/static/includes/_layout.scss b/static/includes/_layout.scss
index 4d0a66fc..34d24346 100644
--- a/static/includes/_layout.scss
+++ b/static/includes/_layout.scss
@@ -1,7 +1,7 @@
-$width: 1000px !default;
-$mobile-limit: 800px !default;
-$mobile-width: null !default;
-$very-small-limit: 480px !default;
+$width: 1280px !default;
+$mobile-limit: 1024px !default;
+$mobile-width: 720px !default;
+$very-small-limit: 560px !default;
 $columns-gutter: 20px !default;
 $footer-background: #666666 !default;
 $footer-full-width-background: true !default;
@@ -50,8 +50,13 @@ div#footer,
 div#main-content-wrapper,
 .page-width {
 	clear: both;
-	max-width: $width;
+	@media (min-desktop-viewport) {
+		max-width: $width;
+	}
 	margin: 0 auto;
+}
+
+div#main-content-wrapper {
 	@if ($mobile-width) {
 		@media ($max-mobile-viewport) {
 			max-width: $mobile-width;
diff --git a/static/isere-cd38/_vars.scss b/static/isere-cd38/_vars.scss
index f15e49e5..d089271d 100644
--- a/static/isere-cd38/_vars.scss
+++ b/static/isere-cd38/_vars.scss
@@ -30,6 +30,7 @@ $link-color: $cyan-dark;
 
 $width: 1920px;
 $mobile-limit: 70em;
+$mobile-width: none;
 $nav-mobile-limit: 50em;
 $very-small-limit: 560px;
 $font-family: $source-sans;
diff --git a/static/la-hague/_vars.scss b/static/la-hague/_vars.scss
index 81e366c9..462770bf 100644
--- a/static/la-hague/_vars.scss
+++ b/static/la-hague/_vars.scss
@@ -1,6 +1,7 @@
 $primary-color: #5ABEB9;
 
 $width: 1200px;
+$mobile-width: none;
 $font-color: #515151;
 $font-size: 0.812em;
 $font-family: Verdana, Arial, sans-serif;
diff --git a/static/la-reunion-region/_vars.scss b/static/la-reunion-region/_vars.scss
index 39f21809..687a5ff1 100644
--- a/static/la-reunion-region/_vars.scss
+++ b/static/la-reunion-region/_vars.scss
@@ -13,6 +13,7 @@ $desaturate-orange: #a9987b;
 // Core Vars
 $mobile-limit: 960px;
 $width: 1160px;
+$mobile-width: none;
 $primary-color: $dark-blue;
 $link-color: $primary-color;
 $font-family: "Helvetica Neue", Helvetica, Arial, sans-serif;
diff --git a/static/lanester/_custom.scss b/static/lanester/_custom.scss
index 7cce70c4..49a80e70 100644
--- a/static/lanester/_custom.scss
+++ b/static/lanester/_custom.scss
@@ -2,6 +2,9 @@
 
 // Header
 #header {
+	@media ($max-mobile-viewport) {
+		max-width: $mobile-width;
+	}
 	h1#logo.has-logo {
 		left: 0.4375rem;
 		a {
@@ -79,6 +82,12 @@ div.links-list ul > li {
 }
 
 // Footer
+div#footer {
+	@media ($max-mobile-viewport) {
+		max-width: $mobile-width;
+	}
+}
+
 #footer-wrapper {
 	padding-top: none;
 	background: url(/assets/footer:background) no-repeat;
diff --git a/static/lattes/_vars.scss b/static/lattes/_vars.scss
index 6471dc58..b6b68708 100644
--- a/static/lattes/_vars.scss
+++ b/static/lattes/_vars.scss
@@ -4,6 +4,7 @@ $font-color: #3F3F3F;
 $font-size: 0.875em;
 $font-family: Montserrat, sans-serif;
 $width: 1100px;
+$mobile-width: none;
 $border-radius: 0;
 
 $nav-background: rgba(248, 248, 248, 0.8);
diff --git a/static/lille/_vars.scss b/static/lille/_vars.scss
index 30921613..799fd688 100644
--- a/static/lille/_vars.scss
+++ b/static/lille/_vars.scss
@@ -9,6 +9,7 @@ $link-color: $primary-color;
 
 $body-background: #e5e5e5;
 $width: 1200px;
+$mobile-width: none;
 $footer-background: white;
 $footer-color: black;
 $nav-mobile-limit: 50000px;
diff --git a/static/marseille/_vars.scss b/static/marseille/_vars.scss
index e223ea6d..153e2386 100644
--- a/static/marseille/_vars.scss
+++ b/static/marseille/_vars.scss
@@ -24,6 +24,7 @@ $body-background: $flesh;
 
 $width: 1200px;
 $mobile-limit: 1024px;
+$mobile-width: none;
 $very-small-limit: 560px;
 $columns-gutter: 30px;
 
diff --git a/static/montpellier-ville/_vars.scss b/static/montpellier-ville/_vars.scss
index 2b0b57a2..0e137904 100644
--- a/static/montpellier-ville/_vars.scss
+++ b/static/montpellier-ville/_vars.scss
@@ -10,6 +10,7 @@ $font-family: dejarip, arial, helvetica, sans-serif;
 $link-color: $primary-color;
 
 $width: 1200px;
+$mobile-width: none;
 
 $title-background: transparent;
 $title-color: $primary-color;
diff --git a/static/roannais-icitoyen/_vars.scss b/static/roannais-icitoyen/_vars.scss
index b1985fe0..3f0d03c3 100644
--- a/static/roannais-icitoyen/_vars.scss
+++ b/static/roannais-icitoyen/_vars.scss
@@ -81,6 +81,7 @@ $logo-size: 80px;
 // Core Vars
 $width: 1280px;
 $mobile_limit: 1024px;
+$mobile-width: none;
 $very-small-limit: 560px;
 $sidebar-width: 17.5rem;
 $primary-color: $red-orange;
diff --git a/static/sospel/_vars.scss b/static/sospel/_vars.scss
index 059fe34c..c2c5ec93 100644
--- a/static/sospel/_vars.scss
+++ b/static/sospel/_vars.scss
@@ -2,6 +2,7 @@
 
 $primary-color: #333333;
 
+$mobile-width: none;
 $link-color: #00b7f3;
 $font-color: black;
 $font-size: 0.812em;
diff --git a/static/thonon-agglomeration/_vars.scss b/static/thonon-agglomeration/_vars.scss
index 880c5248..92997ded 100644
--- a/static/thonon-agglomeration/_vars.scss
+++ b/static/thonon-agglomeration/_vars.scss
@@ -3,6 +3,7 @@ $link-color: #253a8e;
 $font-family: "Roboto", sans-serif; // "Roboto", Gill Sans, sans-serif;
 $footer-background: #1c1b19;
 $border-radius: 3px;
+$mobile-width: none;
 
 $title-background: #fec307;
 $title-color: #222;
diff --git a/static/toulouse-metropole/_vars.scss b/static/toulouse-metropole/_vars.scss
index bd1f654c..f83cb0fb 100644
--- a/static/toulouse-metropole/_vars.scss
+++ b/static/toulouse-metropole/_vars.scss
@@ -5,6 +5,7 @@ $primary-color: $orange;
 $border-radius: 3px;
 $font-family: AauxPro, Arial, Helvetica, sans-serif;
 $width: auto;
+$mobile-width: none;
 $font-color: #666;
 $font-size: 0.812em;
 
diff --git a/static/toulouse/_vars.scss b/static/toulouse/_vars.scss
index 6c84b7b9..91449cd9 100644
--- a/static/toulouse/_vars.scss
+++ b/static/toulouse/_vars.scss
@@ -3,6 +3,7 @@ $primary-color: #de3559;
 $border-radius: 3px;
 $font-family: Montserrat, Arial, sans-serif;
 $width: auto;
+$mobile-width: none;
 $font-color: #666;
 $font-size: 0.812em;
 $columns-gutter: 3rem;
diff --git a/static/venissieux/_vars.scss b/static/venissieux/_vars.scss
index f9efff0e..115999a9 100644
--- a/static/venissieux/_vars.scss
+++ b/static/venissieux/_vars.scss
@@ -5,6 +5,7 @@ $font-size: 1em;
 $font-family: Cantarell, sans-serif;
 
 $width: 1400px;
+$mobile-width: none;
 
 $nav-after-image: false;
 
-- 
2.35.1