From ccbada28f739f788dd1b3ee73f4a2e38bde2c0b6 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Wed, 13 Apr 2022 19:17:32 +0200
Subject: [PATCH] translations: update to use "Modifier" and "Enregistrer"
 (#63910)

---
 .../locale/fr/LC_MESSAGES/django.po           | 20 +++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

diff --git a/src/authentic2/locale/fr/LC_MESSAGES/django.po b/src/authentic2/locale/fr/LC_MESSAGES/django.po
index 71896ab0..950769c0 100644
--- a/src/authentic2/locale/fr/LC_MESSAGES/django.po
+++ b/src/authentic2/locale/fr/LC_MESSAGES/django.po
@@ -8,7 +8,7 @@ msgstr ""
 "Project-Id-Version: Authentic\n"
 "Report-Msgid-Bugs-To: \n"
 "POT-Creation-Date: 2022-04-06 10:46+0200\n"
-"PO-Revision-Date: 2022-04-06 10:48+0200\n"
+"PO-Revision-Date: 2022-04-13 19:16+0200\n"
 "Last-Translator: Mikaël Ates <mates@entrouvert.com>\n"
 "Language-Team: None\n"
 "Language: fr\n"
@@ -2575,7 +2575,7 @@ msgstr "Ajouter une collectivité"
 
 #: src/authentic2/manager/ou_views.py
 msgid "Edit organizational unit"
-msgstr "Éditer la collectivité"
+msgstr "Modifier la collectivité"
 
 #: src/authentic2/manager/ou_views.py
 msgid "Delete organizational unit"
@@ -2690,7 +2690,7 @@ msgstr "Rôle déjà autorisé dans ce service."
 
 #: src/authentic2/manager/service_views.py
 msgid "Edit service"
-msgstr "Éditer le service"
+msgstr "Modifier le service"
 
 #: src/authentic2/manager/tables.py src/authentic2/models.py
 msgid "disabled"
@@ -2837,7 +2837,7 @@ msgstr "Télécharger la liste en CSV"
 #: src/authentic2/manager/templates/authentic2/manager/form.html
 #: src/authentic2/manager/templates/authentic2/manager/role_edit.html
 msgid "Save"
-msgstr "Sauvegarder"
+msgstr "Enregistrer"
 
 #: src/authentic2/manager/templates/authentic2/manager/form.html
 #: src/authentic2/manager/templates/authentic2/manager/user_import.html
@@ -2982,7 +2982,7 @@ msgstr "Vous n’êtes pas autorisé à supprimer cette collectivité."
 #: src/authentic2/manager/templates/authentic2/manager/user_detail.html
 #: src/authentic2/manager/templates/authentic2/manager/user_edit.html
 msgid "Edit"
-msgstr "Éditer"
+msgstr "Modifier"
 
 #: src/authentic2/manager/templates/authentic2/manager/ou_detail.html
 msgid "You do not have the rights to edit this organizational unit."
@@ -3008,7 +3008,7 @@ msgstr "Vous n’êtes pas autorisé."
 
 #: src/authentic2/manager/templates/authentic2/manager/role_members.html
 msgid "This role is technical, you cannot edit it."
-msgstr "Ce rôle est interne, vous ne pouvez pas l’éditer."
+msgstr "Ce rôle est interne, vous ne pouvez pas le modifier."
 
 #: src/authentic2/manager/templates/authentic2/manager/role_members.html
 msgid "This role is technical, you cannot delete it."
@@ -3257,7 +3257,7 @@ msgstr "Modifier les rôles"
 
 #: src/authentic2/manager/templates/authentic2/manager/user_common_roles.html
 msgid "Edit User Roles"
-msgstr "Éditer les rôles de l’utilisateur"
+msgstr "Modifier les rôles de l’utilisateur"
 
 #: src/authentic2/manager/templates/authentic2/manager/user_create_registration_email_body.txt
 #, python-format
@@ -3907,7 +3907,7 @@ msgstr "Modifier"
 
 #: src/authentic2/manager/user_views.py
 msgid "Edit user"
-msgstr "Éditer l’utilisateur"
+msgstr "Modifier l’utilisateur"
 
 #: src/authentic2/manager/user_views.py
 #: src/authentic2/saml/templates/admin/saml/libertyprovider/add_from_url.html
@@ -3976,7 +3976,7 @@ msgstr "Supprimer l’objet « %s »"
 #: src/authentic2/manager/views.py
 #, python-format
 msgid "Edit %s"
-msgstr "Éditer l’objet « %s »"
+msgstr "Modifier l’objet « %s »"
 
 #: src/authentic2/manager/views.py
 msgid "Site Import"
@@ -4714,7 +4714,7 @@ msgstr "Modifier votre adresse électronique"
 
 #: src/authentic2/templates/authentic2/accounts.html src/authentic2/views.py
 msgid "Edit account data"
-msgstr "Éditer les données du compte"
+msgstr "Modifier les données du compte"
 
 #: src/authentic2/templates/authentic2/accounts.html
 msgid "Manage service authorizations"
-- 
2.35.2